from Products.PloneSiteMap import install_globals
from Products.PloneSiteMap.global_symbols import *
from Products.PloneSiteMap.Installation import Installation
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.PortalFolder import PortalFolder
from cStringIO import StringIO


def install(self):
    # Install properties
    if not hasattr(self.portal_properties, 'plonesitemap_properties'):
        self.portal_properties.addPropertySheet('plonesitemap_properties', 'PloneSiteMap properties')
    
    props = self.portal_properties.plonesitemap_properties
    
    if not hasattr(props, 'root'):
        props._setProperty('root', "", 'string')
    
    sitemap_properties = (
        ('root', 'string', ''),
        ('metaTypesToDig', 'lines', ['Plone Folder']),
        ('metaTypesNotToList', 'lines', []),
        ('statesToList', 'lines', ['published']),
        ('idsNotToList', 'lines', []),
        ('bottomLevel', 'int', 3),
        ('inlineLastLevel', 'boolean', 1),
        ('showIcons', 'boolean', 1),
        ('showDescription', 'boolean', 0),
        ('metaTypesNotToDescribe', 'lines', []),
        ('sortAlphabetically', 'boolean', 1),
        )
    
    for prop_id, prop_type, prop_value in sitemap_properties:
        if not hasattr(props, prop_id):
            props._setProperty(prop_id, prop_value, prop_type)
    
    installation=Installation(self)
    installation.setupTypesandSkins([], SKIN_NAME, install_globals)
    for ctype in ['PloneSiteMap',]:
        validation = []
        installation.addFormValidators(validation)
        lowertype = 'default'

    pa = getToolByName(self, 'portal_actions')
    isActionDefined=0
    pa.addAction(
                     'sitemap',
                     'SiteMap',
                     'string:$portal_url/sitemap',
                     '',
                     'View',
                     'portal_tabs'
                    )
    installation.out.write('New action tab sitemap added.\n')
    
    #configlet
    pcp = getToolByName(self, 'portal_controlpanel')
    pcp.registerConfiglet(**prefs_plonesitemap_configlet)
    installation.out.write('SiteMap configlet added.\n')
    
    return installation.report()

def uninstall(self):
    out = StringIO()
    
    # uninstall configlets
    try:
        self.portal_controlpanel.unregisterApplication(PROJECTNAME)
    except:
        pass
    
    out.write("PloneSiteMap Configlet successfully uninstalled.")
    return out.getvalue()
