## Script (Python) "PloneSiteMap"
##parameters=root=None, metaTypesToDig=['Plone Folder'], metaTypesNotToList=[], statesToList=['published'], idsNotToList=['Members'], depth=3, sortAlphabetically=1
##title=Generate the map of the site

from Products.CMFCore.utils import getToolByName

siteMap=[]
portal_workflow = getToolByName(context, 'portal_workflow')
portal_url = getToolByName(context, 'portal_url')
portal_type = getToolByName(context, 'portal_type')

if root == None:
    root = portal_url.getPortalObject() # Site Root

if context.portal_properties.plonesitemap_properties.bottomLevel == depth:
    objectIds = root.contentIds(metaTypesToDig)
else:
    objectIds = root.contentIds()

if depth == 0:
  return []
else: 
  for objectId in objectIds:
    try:
         object = getattr(root, objectId) # should raise if object is Private
         object_type = getattr(object, 'portal_type') 
         
         if object_type == 'I18NLayer' and object_type != object.Type():
             object = object.retrieveLanguageContent()
         
         object_metatype = object.getTypeInfo().Metatype()
         object_state = portal_workflow.getInfoFor(object, 'review_state', None)
         
         if object.getId() not in idsNotToList and object_metatype not in metaTypesNotToList and (not statesToList or  object_state in statesToList):
            if object_metatype in metaTypesToDig and object.isPrincipiaFolderish:
                siteMap.append( 
                                (object, 
                                 container.getSiteMap(object, 
                                                      metaTypesToDig, 
                                                      metaTypesNotToList, 
                                                      statesToList,
                                                      idsNotToList, 
                                                      depth - 1, 
                                                      sortAlphabetically)) 
                              )
            else:
                siteMap.append( (object, []) )
    except:
        pass

  # Sort list
  if sortAlphabetically:
      siteMap.sort(lambda a,b:cmp(a[0].title_or_id().lower(), b[0].title_or_id().lower()))

return siteMap
